function x = rls(Y,a0,P0,lambda)
% Y  NxT observation data 
% a0 px1 initial estimate of AR parameters
% P0 pxp initial cov estimate of AR parameters
% lambda forgetting factor
% Written by Emtiyaz @ IISc.

p=size(a0,1);

h0=Y(:,1:p);%initial values pXN
y=Y(:,p+1:end);
[N,T]=size(y);

atsum=zeros(p,T);
frls=zeros(N,T);
x=zeros(N,p,T);
for i=1:N
	%initialization
	at=zeros(p,T);
	Pt=zeros(p,p,T);
	ht=h0(i,:)';

	z1=P0*ht;
	k1=z1/(lambda+ht'*z1);
	e1=y(i,1)-a0'*ht;
	at(:,1)=a0+e1*k1;
	Pt(:,:,1)=(P0-k1*ht'*P0)/lambda;
	ht=[y(i,1); ht(1:end-1)];

	%update equations of RLS
	for t=2:T
		zt=Pt(:,:,t-1)*ht;
		kt=zt/(lambda+ht'*zt);
		e(t)=y(i,t)-at(:,t-1)'*ht;
		at(:,t)=at(:,t-1)+e(t)*kt;
		Pt(:,:,t)=(Pt(:,:,t-1)-kt*ht'*Pt(:,:,t-1))/lambda;
		ht=[y(i,t); ht(1:end-1)];

		a_t=zeros(p,1);
		a_t(:)=at(:,t);
	end
	x(i,:,:)=at;
end


