function zplot(z)
% pole plot
% Written by Emtiyaz @ IISc.

ax=newplot;
kids = get(ax,'Children');
for i = 1:length(kids)
   delete(kids(i));
end
set(ax,'box','on')
set(ax,'xlimmode','auto','ylimmode','auto')
% equivalent of 'hold on':
set(ax,'nextplot','add')
set(get(ax,'parent'),'nextplot','add')
 
%PLOT THE DATA HERE
plot(z);

theta = linspace(0,2*pi,70);
oh = plot(cos(theta),sin(theta),':');
 
% inline 'axis equal'
units = get(ax,'Units'); set(ax,'Units','Pixels')
apos = get(ax,'Position'); set(ax,'Units',units)
set(ax,'DataAspectRatio',[1 1 1],...
   'PlotBoxAspectRatio',apos([3 4 4]))
 
%  zoom out ever so slightly (5%)
 
if apos(3) < apos(4)
   yl=get(ax,'ylim');
   d=diff(yl);
   yl = [yl(1)-.05*d  yl(2)+.05*d];
   set(ax,'ylim',yl);
   xl = get(ax,'xlim');
else
   xl=get(ax,'xlim');
   d=diff(xl);
   xl = [xl(1)-.05*d  xl(2)+.05*d];
   set(ax,'xlim',xl);
   yl = get(ax,'ylim');
end
set(oh,'xdat',[get(oh,'xdat') NaN ...
      xl(1)-diff(xl)*100 xl(2)+diff(xl)*100 NaN 0 0]);
set(oh,'ydat',[get(oh,'ydat') NaN 0 0 NaN ...
      yl(1)-diff(yl)*100 yl(2)+diff(yl)*100]);
set(oh(2:length(oh)),'vertical','bottom');
 
set(get(ax,'xlabel'),'string','Real Part')
set(get(ax,'ylabel'),'string','Imaginary Part')
set(ax,'nextplot','replace')
set(get(ax,'parent'),'nextplot','replace')

